# AWS Services Supported

The alpha SDK for Rust currently supports the checked services below. If you want to see a particular service added, please add your "+1" to the GitHub issue corresponding to the service. If the Issue doesn't exist yet, feel free to create one! This will help us prioritize adding new services to the SDK. 

## Tier 1 Supported
These services have been tested and include usage examples

- [x] Amazon API Gateway
- [x] Amazon Dynamodb
- [x] Amazon Kinesis
- [x] Amazon KMS
- [x] Amazon Polly
- [x] Amazon Secrets Manager
- [X] Amazon Qldb
- [X] Amazon Qldb-Session
- [X] Amazon Lambda
- [x] [Amazon S3](https://github.com/awslabs/aws-sdk-rust/issues/16)
- [x] [Amazon SSM](https://github.com/awslabs/aws-sdk-rust/issues/22)
- [x] [Amazon SQS](https://github.com/awslabs/aws-sdk-rust/issues/19)
- [x] [Amazon ECS](https://github.com/awslabs/aws-sdk-rust/issues/28)
- [x] Amazon Batch
- [x] [Amazon Route 53](https://github.com/awslabs/aws-sdk-rust/issues/35)
- [x] [Amazon RDS](https://github.com/awslabs/aws-sdk-rust/issues/36)
- [x] Amazon Rds-Data
- [x] [Amazon IAM](https://github.com/awslabs/aws-sdk-rust/issues/21)
- [x] [Amazon SNS](https://github.com/awslabs/aws-sdk-rust/issues/26)
- [x] [Amazon Sts](https://github.com/awslabs/aws-sdk-rust/issues/17)
- [x] Amazon Medialive
- [x] Amazon Mediapackage
- [x] [Amazon Cloud Formation](https://github.com/awslabs/aws-sdk-rust/issues/25)
- [x] Amazon Sagemaker
- [x] Amazon Sagemaker-A2I-Runtime
- [x] Amazon Runtime.Sagemaker
- [x] [Amazon Ec2](https://github.com/awslabs/aws-sdk-rust/issues/18)
- [x] [Amazon SES v2](https://github.com/awslabs/aws-sdk-rust/issues/27)
- [x] [Amazon Cloudwatch Logs](https://github.com/awslabs/aws-sdk-rust/issues/30)
- [x] [Amazon ECR](https://github.com/awslabs/aws-sdk-rust/issues/34)
- [x] [Amazon EKS](https://github.com/awslabs/aws-sdk-rust/issues/67)
- [x] [Amazon Cloudwatch Metrics](https://github.com/awslabs/aws-sdk-rust/issues/20)
- [x] [Amazon EBS](https://github.com/awslabs/aws-sdk-rust/issues/66)
- [x] [Amazon Config](https://github.com/awslabs/aws-sdk-rust/issues/31)
- [x] [Amazon Cognito Identity](https://github.com/awslabs/aws-sdk-rust/issues/124)
- [x] [Amazon Cognito Identity Provider](https://github.com/awslabs/aws-sdk-rust/issues/124)
- [x] [Amazon Cognito Sync](https://github.com/awslabs/aws-sdk-rust/issues/124)
- [x] Amazon Snowball
- [x] [Amazon Auto Scaling](https://github.com/awslabs/aws-sdk-rust/issues/33)
- [x] Amazon Autoscaling
- [x] Amazon Autoscaling-Plans

## Tier 2 Support
These services have not yet been manually tested by the SDK team and may not have usage examples yet. Please report any issues you find!

- [x] Amazon Access Analyzer
- [x] Amazon ACM
- [x] Amazon Acm-Pca
- [x] Amazon Alexa For Business
- [x] Amazon Amplify
- [x] Amazon API Gateway Management API
- [x] Amazon API Gateway v2
- [x] Amazon App Config
- [x] Amazon App Flow
- [x] Amazon Application-Insights
- [x] Amazon Appmesh
- [x] Amazon Appstream
- [x] Amazon App Sync
- [x] Amazon Athena
- [x] Amazon Awsmigrationhub
- [x] Amazon Backup
- [x] Amazon Braket
- [x] Amazon Budgets
- [x] Amazon Ce
- [x] Amazon Chime
- [x] Amazon Chime Identity
- [x] Amazon Chime Messaging
- [x] Amazon Cloud9
- [x] Amazon Cloud Directory
- [x] Amazon Cloud Front
- [x] Amazon Cloudhsm
- [x] Amazon Cloudhsmv2
- [x] Amazon Cloudsearch
- [x] Amazon Cloudsearchdomain
- [x] Amazon Cloud Trail
- [x] Amazon Code Artifact
- [x] Amazon Code Build
- [x] Amazon Code Commit
- [x] Amazon Code Deploy
- [x] Amazon Code Guru Profiler
- [x] Amazon Code Guru Reviewer
- [x] Amazon Code Pipeline
- [x] Amazon Codestar
- [x] Amazon Codestar-Connections
- [x] Amazon Codestar-Notifications
- [x] Amazon Comprehend
- [x] Amazon Comprehendmedical
- [x] Amazon Compute-Optimizer
- [x] Amazon Connect
- [x] Amazon Connectparticipant
- [x] Amazon Cur
- [x] Amazon Databrew
- [x] Amazon Dataexchange
- [x] Amazon Datapipeline
- [x] Amazon Datasync
- [x] Amazon Dax
- [x] Amazon Detective
- [x] Amazon Device Farm
- [x] Amazon Direct Connect
- [x] Amazon Discovery
- [x] Amazon Dlm
- [x] Amazon DMS
- [x] Amazon Docdb
- [x] Amazon DS
- [x] Amazon Ec2-Instance-Connect
- [x] Amazon Elasticache
- [x] Amazon Elastic Beanstalk
- [x] Amazon Elastic Filesystem
- [x] Amazon Elastic Inference
- [x] Amazon Elastic Load Balancing
- [x] Amazon Elastic Load Balancing v2
- [x] Amazon Elastic Map Reduce
- [x] Amazon Elastic Transcoder
- [x] Amazon Email
- [x] Amazon Entitlement.Marketplace
- [x] Amazon ES
- [x] Amazon Eventbridge
- [x] Amazon Events
- [x] Amazon Firehose
- [x] Amazon FMS
- [x] Amazon Forecast
- [x] Amazon Forecast Query
- [x] Amazon Fraud Detector
- [x] Amazon FSX
- [x] Amazon Gamelift
- [x] Amazon Global Accelerator
- [x] Amazon Glue
- [x] Amazon Greengrass
- [x] Amazon Groundstation
- [x] Amazon Guardduty
- [x] Amazon Health
- [x] Amazon Honeycode
- [x] Amazon Identitystore
- [x] Amazon Imagebuilder
- [x] Amazon Inspector
- [x] Amazon IOT
- [x] Amazon Iot1Click-Devices
- [x] Amazon Iot1Click-Projects
- [x] Amazon IoT Analytics
- [x] Amazon IoT Data
- [x] Amazon IoT Events
- [x] Amazon Iotevents-Data
- [x] Amazon Iot-Jobs-Data
- [x] Amazon Iotsecuretunneling
- [x] Amazon Iotsitewise
- [x] Amazon Iotthingsgraph
- [x] Amazon Ivs
- [x] Amazon Kafka
- [x] Amazon Kendra
- [x] Amazon Kinesis Analytics
- [x] Amazon Kinesis Analytics v2
- [x] Amazon Kinesis Video
- [x] Amazon Kinesis-Video-Archived-Media
- [x] Amazon Kinesis-Video-Media
- [x] Amazon Kinesis-Video-Signaling
- [x] Amazon Lake Formation
- [x] Amazon Lambda
- [x] Amazon Lex-Models
- [x] Amazon License-Manager
- [x] Amazon Lightsail
- [x] Amazon Logs
- [x] Amazon Machine Learning
- [x] Amazon Macie
- [x] Amazon Macie2
- [x] Amazon Managedblockchain
- [x] Amazon Marketplace-Catalog
- [x] Amazon Marketplacecommerceanalytics
- [x] Amazon Mediaconnect
- [x] Amazon Mediaconvert
- [x] Amazon Mediapackage-Vod
- [x] Amazon Mediastore
- [x] Amazon Mediastore-Data
- [x] Amazon Mediatailor
- [x] Amazon MemoryDB
- [x] Amazon Meteringmarketplace
- [x] Amazon Migrationhub-Config
- [x] Amazon Mobile
- [x] Amazon Monitoring
- [x] Amazon Mq
- [x] Amazon Mturk-Requester
- [x] Amazon Neptune
- [x] Amazon Network-Firewall
- [x] Amazon Networkmanager
- [x] Amazon Opensearch
- [x] Amazon Ops Works
- [x] Amazon Opsworkscm
- [x] Amazon Organizations
- [x] Amazon Outposts
- [x] Amazon Personalize
- [x] Amazon Personalize-Events
- [x] Amazon Personalize-Runtime
- [x] Amazon Pi
- [x] Amazon Pinpoint
- [x] Amazon Pinpoint-Email
- [x] Amazon Pricing
- [x] Amazon Quicksight
- [x] Amazon RAM
- [x] Amazon Redshift
- [x] Amazon Redshift-Data
- [x] Amazon Rekognition
- [x] Amazon Resource-Groups
- [x] Amazon Resourcegroupstaggingapi
- [x] Amazon Robomaker
- [x] Amazon Route53Domains
- [x] Amazon Route53Resolver
- [x] Amazon Runtime.Lex
- [x] Amazon S3Control
- [x] Amazon S3Outposts
- [x] Amazon Savingsplans
- [x] Amazon Schemas
- [x] Amazon Securityhub
- [x] Amazon Serverlessrepo
- [x] Amazon Servicecatalog
- [x] Amazon Servicecatalog-Appregistry
- [x] Amazon Service Discovery
- [x] Amazon Service-Quotas
- [x] Amazon Shield
- [x] Amazon Signer
- [x] Amazon SMS
- [x] Amazon Sms-Voice
- [x] Amazon Snow Device Management
- [x] Amazon SSO
- [x] Amazon Sso-Admin
- [x] Amazon Sso-Oidc
- [x] Amazon States
- [x] Amazon Storagegateway
- [x] Amazon Streams.Dynamodb
- [x] Amazon Support
- [x] Amazon Swf
- [x] Amazon Synthetics
- [x] Amazon Textract
- [x] Amazon Transcribe
- [x] Amazon Transcribe-Streaming
- [x] Amazon Transfer
- [x] Amazon Translate
- [x] Amazon Waf
- [x] Amazon Waf-Regional
- [x] [Amazon Wafv2](https://github.com/awslabs/aws-sdk-rust/issues/118)
- [x] Amazon Workdocs
- [x] Amazon Worklink
- [x] Amazon Workmail
- [x] Amazon Workmailmessageflow
- [x] Amazon Workspaces
- [x] Amazon Xray

## No support (yet)
We're working on it! Please file or upvote on the relevant issue to help us prioritize.
- [ ] Amazon Glacier
- [ ] Amazon Timestream-Query
- [ ] Amazon Timestream-Write
